using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.IO;
using Infragistics.Win.AppStyling;
using Infragistics.Win.AppStyling.Runtime;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();            
        }        

        private DataTable dt1;

        private void Form1_Load(object sender, System.EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(4, new Type[] { typeof(int), typeof(int), typeof(int), typeof(string) });
            dt1.TableName = "Band 0";

            dt1.Rows[0]["String 1"] = "";
            dt1.Rows[1]["String 1"] = "This is line 1";
            dt1.Rows[2]["String 1"] = "This is line 1\r\nThis is line 2";
            dt1.Rows[3]["String 1"] = "This is line 1\r\nThis is line 2\r\nThis is line 3";
            
            dt1.AcceptChanges();

            this.ultraGrid1.SetDataBinding(dt1, null);
        }        

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            UltraGridOverride ov = layout.Override;

            ov.RowSizing = RowSizing.AutoFixed;

            band.RowLayoutStyle = RowLayoutStyle.GroupLayout;
            UltraGridGroup groupA = band.Groups.Add("Group A");

            foreach (var column in band.Columns)
            {
                if (column.Key == "Key")
                    column.Hidden = true;

                column.RowLayoutColumnInfo.ParentGroup = groupA;                
            }

            ov.MinRowHeight = 1;

            band.Columns["String 1"].CellMultiLine = DefaultableBoolean.True;
            band.Columns["String 1"].RowLayoutColumnInfo.OriginY = 2;
            band.Columns["String 1"].RowLayoutColumnInfo.SpanX = 16;
            band.Columns["String 1"].RowLayoutColumnInfo.LabelPosition = LabelPosition.None;

            band.Columns["String 1"].CellMultiLine = DefaultableBoolean.True;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (string.IsNullOrEmpty(e.Row.Cells["String 1"].Value.ToString()))
            {
                e.Row.Height = e.Row.Cells["Int32 1"].Column.CellSizeResolved.Height;
            }
        }
    }
}